/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.9.2.4 by edhill, Fri Oct 3 05:12:18 2003 UTC revision 1.10 by edhill, Thu Oct 9 04:19:20 2003 UTC
# Line 11  usage() Line 11  usage()
11      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
12      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
13      echo "  (-mpi)                   use MPI input files"      echo "  (-mpi)                   use MPI input files"
14        echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
15      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-optfile=|-of=)STRING   list of optfiles to use"
16      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-a|-addr)STRING         list of email recipients"
17      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"edhill@mitgcm.org\")"
# Line 18  usage() Line 19  usage()
19      echo "                             (DEF=\"\" which builds all)"      echo "                             (DEF=\"\" which builds all)"
20      echo "  (-b|-bash)STRING         location of \"bash\" executable"      echo "  (-b|-bash)STRING         location of \"bash\" executable"
21      echo "                             (DEF=\"\" for \"/bin/bash\")"      echo "                             (DEF=\"\" for \"/bin/bash\")"
22      echo "  (-c|-command)STRING      command to run"      echo "  (-command)STRING         command to run"
23      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
24      echo "  (-m|-make)STRING         command to use for \"make\""      echo "  (-m|-make)STRING         command to use for \"make\""
25      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
26        echo "  (-clean)                 *ONLY* run \"make CLEAN\""
27      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
28      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
29      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
# Line 184  genmakemodel() Line 186  genmakemodel()
186          GENMAKE2="$BASH ../../../tools/genmake2"          GENMAKE2="$BASH ../../../tools/genmake2"
187          (          (
188              cd $1;              cd $1;
189                command="$GENMAKE2  -ds -m $MAKE --mods=../code"
190                if test "x$OPTFILE" != xNONE ; then
191                    command="$command --optfile=$OPTFILE"
192                    # echo "  command=\"$command\""
193                fi
194                if test "x$IEEE" != x ; then
195                    command="$command -ieee"
196                fi
197                # echo "command: \"$command\""
198              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
199              # ../../../tools/genmake -ieee -mods=../code > make.log 2>&1              $command > make.log 2>&1
             $GENMAKE2  -ds -m $MAKE --mods=../code "--optfile="$OPTFILE > make.log 2>&1  
200              RETVAL=$?              RETVAL=$?
201              for i in gm_state gm_optfile gm_local Makefile ; do              for i in genmake_state genmake_optfile genmake_local Makefile ; do
202                  if test -r $i ; then                  if test -r $i ; then
203                      cp $i $CDIR                      cp $i $CDIR
204                  fi                  fi
# Line 383  $0 [-help] [-quick] [-verbose] dir1 [dir Line 393  $0 [-help] [-quick] [-verbose] dir1 [dir
393   -debug     Produce even more output which will mean nothing to most   -debug     Produce even more output which will mean nothing to most
394   -force     Do "make CLEAN" before compiling. This forces a complete rebuild.   -force     Do "make CLEAN" before compiling. This forces a complete rebuild.
395   -clean     Do "make CLEAN" after compiling and testing.   -clean     Do "make CLEAN" after compiling and testing.
  -noieee    By default, $0 uses the -ieee option for genmake. This turns it off.  
396   -cleanup   Aggresively removes all model output, executables and object files   -cleanup   Aggresively removes all model output, executables and object files
397              and then exits. Use with care.              and then exits. Use with care.
398    
# Line 416  clean=0 Line 425  clean=0
425  expts=''  expts=''
426  # ieee=1  # ieee=1
427    
428    IEEE=
429    if test "x$MITGCM_IEEE" != x ; then
430        IEEE=$MITGCM_IEEE
431    fi
432    
433    
434  CLEANUP=f  CLEANUP=f
435  QUICK=f  QUICK=f
436  NOGENMAKE=f  NOGENMAKE=f
# Line 423  NOCLEAN=f Line 438  NOCLEAN=f
438  NODEPEND=f  NODEPEND=f
439    
440  BASH=  BASH=
441  OPTFILES=  OPTFILE=NONE
442  ADDRESSES=  ADDRESSES=
443  TESTDIRS=  TESTDIRS=
444  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
# Line 452  for ac_option ; do Line 467  for ac_option ; do
467              usage ;;              usage ;;
468                    
469          -optfile | --optfile | -of | --of)          -optfile | --optfile | -of | --of)
470              ac_prev=OPTFILES ;;              ac_prev=OPTFILE ;;
471          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
472              OPTFILES=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
473                    
474          -addr | --addr | -a | --a)          -addr | --addr | -a | --a)
475              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
# Line 493  for ac_option ; do Line 508  for ac_option ; do
508          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
509              NODEPEND=t ;;              NODEPEND=t ;;
510    
511          -mpi) MPI=t ;;          -mpi) MPI=true ;;
512    
513            -ieee) IEEE=true ;;
514            -noieee) IEEE= ;;
515    
516          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
517          -debug) debug=1 ;;          -debug) debug=1 ;;
         -clean) clean=1 ;;  
518          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
519    
520          -*)          -*)
# Line 523  if test "x$TESTDIRS" = x ; then Line 541  if test "x$TESTDIRS" = x ; then
541      TESTDIRS=`scandirs`      TESTDIRS=`scandirs`
542  fi  fi
543    
544  if test "x$OPTFILES" = x ; then  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
545      OPTFILES=$MITGCM_OF      OPTFILE=$MITGCM_OF
 fi  
 if test "x$OPTFILES" = x ; then  
     echo "Error: please specify an optfile using either the command-line or"  
     echo "  the MITGCM_OF environment variable.  Also, examples are located "  
     echo "  in \$ROOTDIR/tools/build_options"  
     exit 1  
546  fi  fi
547    
548  echo "OK"  echo "OK"
# Line 571  EOF Line 583  EOF
583    
584  NDIR=0  NDIR=0
585    
586  #  For each optfile...  if test "x$OPTFILE" != xNONE ; then
587  for OPTFILE in $OPTFILES ; do      if test -r $OPTFILE ; then
588            OPTFILE=`pwd`"/$OPTFILE"
     OPTFILE=`pwd`"/$OPTFILE"  
     if test ! -r $OPTFILE ; then  
         echo "Error: can't read optfile \"$OPTFILE\""  
         exit 1  
589      fi      fi
590      echo  fi
591      echo "OPTFILE=$OPTFILE" >> $SUMMARY  echo
592      echo >> $SUMMARY  echo "OPTFILE=$OPTFILE" >> $SUMMARY
593        echo >> $SUMMARY
     #  ...and each test directory...  
     for dir in $TESTDIRS ; do  
   
         #  Cleanup only!  
         if test "x$CLEANUP" = xt ; then  
             if test -r $dir/build/Makefile ; then  
                 ( cd $dir/build ; make CLEAN )  
             fi  
             if test -r $dir/input/Makefile ; then  
                 ( cd $dir/input ; make CLEAN )  
             fi  
             continue  
         fi  
594    
595          #  Verify that the testdir exists and contains previous  #  ...and each test directory...
596          #  results in the correct location--or skip this directory!  for dir in $TESTDIRS ; do
597          if test ! -r $dir"/results/output.txt" ; then      
598              echo      #  Cleanup only!
599              echo "can't read \"$dir/results/output.txt\" -- skipping $dir"      if test "x$CLEANUP" = xt ; then
600              echo          if test -r $dir/build/Makefile ; then
601              continue              ( cd $dir/build ; make CLEAN )
602          fi          fi
603            if test -r $dir/input/Makefile ; then
604          #  Is this an MPI run?              ( cd $dir/input ; make CLEAN )
         if test "x$MPI" = xt ; then  
             if test ! -r $dir"/code/CPP_EEOPTIONS.h_mpi" -o ! -r $dir"/code/SIZE.h_mpi" ; then  
                 echo | tee -a $SUMMARY  
                 echo "can't read \"$dir/code/CPP_EEOPTIONS.h_mpi\" or \"$dir/code/SIZE.h_mpi\"" \  
                     | tee -a $SUMMARY  
                 continue  
             else  
                 cmp $dir"/code/CPP_EEOPTIONS.h_mpi" $dir"/code/CPP_EEOPTIONS.h"  
                 RETVAL=$?  
                 if test "x$RETVAL" != x0 ; then  
                     cp $dir"/code/CPP_EEOPTIONS.h_mpi" $dir"/code/CPP_EEOPTIONS.h"  
                 fi  
                 cmp $dir"/code/SIZE.h_mpi" $dir"/code/SIZE.h"  
                 RETVAL=$?  
                 if test "x$RETVAL" != x0 ; then  
                     cp $dir"/code/SIZE.h_mpi" $dir"/code/SIZE.h"  
                 fi  
             fi  
         else  
             if test -r $dir"/code/CPP_EEOPTIONS.h_nompi" ; then  
                 cmp $dir"/code/CPP_EEOPTIONS.h_nompi" $dir"/code/CPP_EEOPTIONS.h"  
                 RETVAL=$?  
                 if test "x$RETVAL" != x0 ; then  
                     cp $dir"/code/CPP_EEOPTIONS.h_nompi" $dir"/code/CPP_EEOPTIONS.h"  
                 fi  
             fi  
             if test -r $dir"/code/SIZE.h_nompi" ; then  
                 cmp $dir"/code/SIZE.h_nompi" $dir"/code/SIZE.h"  
                 RETVAL=$?  
                 if test "x$RETVAL" != x0 ; then  
                     cp $dir"/code/SIZE.h_nompi" $dir"/code/SIZE.h"  
                 fi  
             fi  
605          fi          fi
606            continue
607        fi
608    
609          #  Create an output dir for each OPTFILE/tdir combination      #  Verify that the testdir exists and contains previous
610          CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR      #  results in the correct location--or skip this directory!
611          mkdir $CDIR      if test ! -r $dir"/results/output.txt" ; then
612          CDIR=`pwd`"/$CDIR"          echo "can't read \"$dir/results/output.txt\" -- skipping $dir"
613            continue
614          #  ...configue, make, run, and compare the output.      fi
         echo "-------------------------------------------------------------------------------"  
         echo  
         echo "Experiment:  $dir"  
         echo  
         unset genmake makedepend make run  
         results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'  
615    
616          if [ -r $dir/build ]; then      echo "-------------------------------------------------------------------------------"
617              seperatebuilddir=1      echo
618              builddir=build      echo "Experiment:  $dir"
619              rundir=build      echo
620              ( cd $dir/build; ln -sf ../input/* . )      unset genmake makedepend make run
621          else      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
             seperatebuilddir=0  
             builddir=input  
             rundir=input  
         fi  
622    
623          if test "x$CLEANUP" = xt ; then      if [ -r $dir/build ]; then
624              makeclean $dir/$builddir          seperatebuilddir=1
625          else          builddir=build
626              genmakemodel $dir/$builddir && genmake=Y \          rundir=build
627                  && makeclean $dir/$builddir \          ( cd $dir/build; ln -sf ../input/* . )
628                  && makedependmodel $dir/$builddir && makedepend=Y \      else
629                  && makemodel $dir/$builddir && make=Y \          seperatebuilddir=0
630                  && linkdata $seperatebuilddir $dir/$rundir \          builddir=input
631                  && runmodel $dir/$builddir && run=Y \          rundir=input
632                  && results=`testoutput $dir $rundir`      fi
633        
634        CODE_DIR=$dir/code
635        BUILD_DIR=$dir/$builddir
636        MPI_FILES="CPP_EEOPTIONS.h_mpi SIZE.h_mpi"
637        NOMPI_FILES="CPP_EEOPTIONS.h_nompi SIZE.h_nompi"
638    
639        #  Is this an MPI run?
640        if test "x$MPI" = xt ; then
641            FILES=$MPI_FILES
642            endings="_mpi"
643        else
644            FILES=$NOMPI_FILES
645            endings="_nompi"
646        fi
647        
648        #  Check to see that we have the files
649        have_files=t
650        for i in $FILES ; do
651            if test ! -r $CODE_DIR/$i ; then
652                echo "Warning: can't read file $CODE_DIR/$i"
653                have_files=f
654          fi          fi
655        done
656          echo      if test "x$have_files" != xt -a "x$MPI" = xt ; then
657          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "Skipping $dir due to lack of input files (see above warning)"
658              ${run:-N} $results          continue
659          echo      fi
660          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \      
661              ${run:-N} $results >> $SUMMARY      #  If we have the $FILES and they differ, copy the $FILES to $BUILD_DIR
662          echo "fresults='" > $CDIR"/summary.txt"      if test "x$have_files" = xt ; then
663          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          for i in $FILES ; do
664              ${run:-N} $results >> $CDIR"/summary.txt"              sstr="s|$endings||"
665          echo "'" >> $CDIR"/summary.txt"              name=`echo $i | sed -e $sstr `
666          echo "MACH='$MACH'" >> $CDIR"/summary.txt"              cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
   
         (  
             cd $DRESULTS  
             tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1  
             gzip $NDIR".tar"  
         )  
   
         if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  
             echo "No mail sent"  
         else  
             $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES  
667              RETVAL=$?              RETVAL=$?
668              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
669                  echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"                  cp $CODE_DIR/$i $BUILD_DIR/$name
             else  
                 rm -f $DRESULTS"/"$NDIR".tar*"  
670              fi              fi
671            done
672        fi
673        
674        #  Create an output dir for each OPTFILE/tdir combination
675        CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR
676        mkdir $CDIR
677        CDIR=`pwd`"/$CDIR"
678        
679        if test "x$CLEANUP" = xt ; then
680            makeclean $dir/$builddir
681        else
682            genmakemodel $dir/$builddir && genmake=Y \
683                && makeclean $dir/$builddir \
684                && makedependmodel $dir/$builddir && makedepend=Y \
685                && makemodel $dir/$builddir && make=Y \
686                && linkdata $seperatebuilddir $dir/$rundir \
687                && runmodel $dir/$builddir && run=Y \
688                && results=`testoutput $dir $rundir`
689        fi
690        
691        echo
692        formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \
693            ${run:-N} $results
694        echo
695        formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \
696            ${run:-N} $results >> $SUMMARY
697        echo "fresults='" > $CDIR"/summary.txt"
698        formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \
699            ${run:-N} $results >> $CDIR"/summary.txt"
700        echo "'" >> $CDIR"/summary.txt"
701        echo "MACH='$MACH'" >> $CDIR"/summary.txt"
702        echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
703        echo "DATE='$DATE'" >> $CDIR"/summary.txt"
704        echo "tdir='$dir'" >> $CDIR"/summary.txt"
705        
706        (
707            cd $DRESULTS
708            tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1
709            gzip $NDIR".tar"
710        )
711        
712        if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
713            echo "No mail sent"
714        else
715            $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES
716            RETVAL=$?
717            if test "x$RETVAL" != x0 ; then
718                echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"
719            else
720                rm -f $DRESULTS"/"$NDIR".tar*"
721          fi          fi
722        fi
723    
724          NDIR=$(( $NDIR + 1 ))      echo "-------------------------------------------------------------------------------"
725                
726      done      NDIR=$(( $NDIR + 1 ))
727        
728  done  done
729    
730  rm tmp_cmpnum.f a.out  rm tmp_cmpnum.f a.out

Legend:
Removed from v.1.9.2.4  
changed lines
  Added in v.1.10

  ViewVC Help
Powered by ViewVC 1.1.22